from server.testserver import get_testdata, send_result
from numpy import nansum


def arithmetic_mean(values: list):
    """ Berechnet den arithmetischen Mittelwert aus einer Zahlenfolge """

    return nansum(values) / len(values)


def test_arithmetic_mean():
    """ Testet den arithmetischen Mittelwert gegen das IUL"""

    response = get_testdata("mean")
    results = []

    for signal in response['signals']:
        # Hole die Parameter des Signals
        test_id = signal['id']
        values = signal['values']

        # Berechne das arithmetische Mittel des Signals
        result = arithmetic_mean(values)

        # Hänge das Ergebnis in der Liste an
        results.append({'id': test_id, 'mean': result})

    # Sende die Ergebnis-Liste zurück an das IUL
    send_result('mean', {'session': response['session'], 'results': results})


if __name__ == '__main__':
    test_arithmetic_mean()