from server.testserver import get_testdata, send_result


def moving_average(window_size: int, values: list):
    """ Berechnet den Gleitenden Mittelwert zu einer Zahlenfolge """

    result = []

    for index in range(0, len(values) - window_size + 1):
        window = values[index: index + window_size]
        average = sum(window) / window_size
        result.append(average)

    return result


def test_moving_average():
    """ Testet den Gleitenden Mittelwert gegen das IUL"""

    response = get_testdata("moving_average")
    results = []

    for signal in response['signals']:
        # Hole die Parameter des Signals
        test_id = signal['id']
        window_size = signal['window']
        values = signal['values']

        # Berechne den Gleitenden Mittelwert des Signals
        result = moving_average(window_size, values)

        # Hänge das Ergebnis in der Liste an
        results.append({'id': test_id, 'values': result})

    # Sende die Ergebnis-Liste zurück an das IUL
    send_result('moving_average', {'session': response['session'], 'results': results})



if __name__ == '__main__':
    test_moving_average()
