from numpy import genfromtxt

from korpus.bewegung import Bewegung
from korpus.messung import Messung
from korpus.sensor import Sensor


def create_bewegung(type):
    sensor_names = ['Acc_X', 'Acc_Y', 'Acc_Z', 'Gyr_X', 'Gyr_Y', 'Gyr_Z', 'Mag_X', 'Mag_Y', 'Mag_Z']
    messungen = []
    anzahl = None
    zeit = None

    for sensor_group_number in range(0, 6):
        data = genfromtxt(f"..\\..\\daten\\{type}\\{type}_sensor{sensor_group_number + 1}.csv",
                          delimiter=',',
                          usecols=(1, 2, 3, 4, 5, 6, 7, 8, 9),
                          skip_header=5)

        sensoren = []
        for sensor_index in range(0, 9):
            sensor = Sensor(sensor_names[sensor_index], data.transpose()[sensor_index])
            sensoren.append(sensor)

        messungen.append(Messung(f"Sensor {sensor_group_number + 1}", sensoren))
        anzahl = len(data)
        zeit = anzahl / 100

    return Bewegung(type, messungen, anzahl, zeit)
